Attribute VB_Name = "basPaths"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit


' Code by I.Runge (mastermind@ircastle.de)
Private Declare Function PathAddBackslash Lib "shlwapi.dll" _
                         Alias "PathAddBackslashA" ( _
                         ByVal pszPath As String) As Long
                         
Private Declare Function PathAddExtension Lib "shlwapi.dll" _
                         Alias "PathAddExtensionA" ( _
                         ByVal pszPath As String, _
                         ByVal pszExt As String) As Long
                         
Private Declare Function PathAppend Lib "shlwapi.dll" _
                         Alias "PathAppendA" ( _
                         ByVal pszPath As String, _
                         ByVal pMore As String) As Long
                         
Private Declare Function PathCanonicalize Lib "shlwapi.dll" _
                         Alias "PathCanonicalizeA" ( _
                         ByVal pszBuf As String, _
                         ByVal pszPath As String) As Long
                         
Private Declare Function PathCommonPrefix Lib "shlwapi.dll" _
                         Alias "PathCommonPrefixA" ( _
                         ByVal pszFile1 As String, _
                         ByVal pszFile2 As String, _
                         ByVal achPath As String) As Long
                         
Private Declare Function PathCompactPathEx Lib "shlwapi.dll" _
                         Alias "PathCompactPathExA" ( _
                         ByVal pszOut As String, _
                         ByVal pszSrc As String, _
                         ByVal cchMax As Long, _
                         ByVal dwFlags As Long) As Long
                         
Private Declare Function PathFileExists Lib "shlwapi.dll" _
                         Alias "PathFileExistsA" ( _
                         ByVal pszPath As String) As Long
                         
Private Declare Function PathIsDirectory Lib "shlwapi.dll" _
                         Alias "PathIsDirectoryA" ( _
                         ByVal pszPath As String) As Long
                         
Private Declare Function PathIsDirectoryEmpty Lib "shlwapi.dll" _
                         Alias "PathIsDirectoryEmptyA" ( _
                         ByVal pszPath As String) As Long
                         
Private Declare Function PathIsPrefix Lib "shlwapi.dll" _
                         Alias "PathIsPrefixA" ( _
                         ByVal pszPrefix As String, _
                         ByVal pszPath As String) As Long
                         
Private Declare Function PathIsRelative Lib "shlwapi.dll" _
                         Alias "PathIsRelativeA" ( _
                         ByVal pszPath As String) As Long
                         
Private Declare Function PathIsRoot Lib "shlwapi.dll" _
                         Alias "PathIsRootA" ( _
                         ByVal pszPath As String) As Long
                         
Private Declare Function PathIsSameRoot Lib "shlwapi.dll" _
                         Alias "PathIsSameRootA" ( _
                         ByVal pszPath1 As String, _
                         ByVal pszPath2 As String) As Long
                         
Private Declare Function PathIsURL Lib "shlwapi.dll" _
                         Alias "PathIsURLA" ( _
                         ByVal pszPath As String) As Long
                         
Private Declare Function PathIsUNC Lib "shlwapi.dll" _
                         Alias "PathIsUNCA" ( _
                         ByVal pszPath As String) As Long
                         
Private Declare Sub PathQuoteSpaces Lib "shlwapi.dll" _
                    Alias "PathQuoteSpacesA" ( _
                    ByVal lpsz As String)
                    
Private Declare Sub PathUnquoteSpaces Lib "shlwapi.dll" _
                    Alias "PathUnquoteSpacesA" ( _
                    ByVal lpsz As String)
                    
Private Declare Function PathStripToRoot Lib "shlwapi.dll" _
                         Alias "PathStripToRootA" ( _
                         ByVal pszPath As String) As Long
                         
Private Declare Function GetFullPathName Lib "kernel32" _
                         Alias "GetFullPathNameA" ( _
                         ByVal lpFileName As String, _
                         ByVal nBufferLength As Long, _
                         ByVal lpBuffer As String, _
                         ByVal lpFilePart As String) As Long
                         
Private Declare Function APIGetShortPathName Lib "kernel32" _
                         Alias "GetShortPathNameA" ( _
                         ByVal lpszLongPath As String, _
                         ByVal lpszShortPath As String, _
                         ByVal cchBuffer As Long) As Long

Public Function AddBackslash(ByVal Path As String) As String
    ' Sicherstellen, dass sich am Ende des Pfades ein \
    ' befindet, also nicht "C:\windows", sondern "C:\windows\"
    Dim sBuf As String
    sBuf = Path + String(100, 0)
    Call PathAddBackslash(sBuf)
    AddBackslash = RemNulls(sBuf)
End Function

Public Function AddExtension(ByVal FileName As String, ByVal Extension As String) As String
    ' Sicherstellen, dass sich am Ende des Dateinamens eine Dateiendung
    ' befindet, also nicht "C:\autoexec", sondern "C:\autoexec.bat"
    ' Extension ist z.B. ".bat" oder ".txt"
    Dim sBuf As String
    sBuf = FileName + String(100, 0)
    Call PathAddExtension(sBuf, Extension)
    AddExtension = RemNulls(sBuf)
End Function

Public Function AppendFileName(ByVal Path As String, ByVal FileName As String) As String
    ' Hngt einen Dateinamen (FileName) wie "test.txt" an einen
    ' Pfad (Path) z.B. "C:\windows\" oder "C:\windows" an.
    Dim sBuf As String
    sBuf = Path + String(100, 0)
    Call PathAppend(sBuf, FileName)
    AppendFileName = RemNulls(sBuf)
End Function

Public Function ParsePath(ByVal Path As String) As String
    ' Macht aus einem Pfad mit relativen Angaben wie z.B.
    ' "C:\windows\.\system32\..\wolken.bmp" einen absoluten wie
    ' "C:\windows\wolken.bmp"
    Dim sBuf As String
    sBuf = Space(255)
    Call PathCanonicalize(sBuf, Path)
    ParsePath = RemNulls(sBuf)
End Function

Public Function EqualPart(ByVal Path1 As String, ByVal Path2 As String) As String
    ' Gibt den gemeinsamen Teil von zwei Pfaden zurck, z.B.
    ' Path1="C:\windows\system\shell32.dll" und Path2="C:\windows\wolken.bmp"
    ' dann ist der Rckgabewert "C:\windows"
    Dim sBuf As String
    sBuf = String(255, 0)
    Call PathCommonPrefix(Path1, Path2, sBuf)
    EqualPart = RemNulls(sBuf)
End Function

Public Function CompactPath(ByVal Path As String, ByVal MaxChars As Long)
    ' Krzt den Pfad auf MaxChars Zeichen, aus
    ' "C:\Programme\Microsoft Visual Studio\VB98"
    ' wird z.B. "C:\Progr...\VB98
    Dim sBuf As String
    sBuf = String(255, 0)
    Call PathCompactPathEx(sBuf, Path, MaxChars, 0&)
    CompactPath = RemNulls(sBuf)
End Function

Public Function FileFolderExists(ByVal Path As String) As Boolean
    ' Stellt fest, ob ein Ordner oder eine Datei existiert
    FileFolderExists = CBool(PathFileExists(Path))
End Function

Public Function IsFolder(ByVal Path As String) As Boolean
    ' Stellt fest, ob Path ein Ordner ist
    IsFolder = CBool(PathIsDirectory(Path))
End Function

Public Function IsFolderEmpty(ByVal Path As String) As Boolean
    ' Stellt fest, ob ein Ordner leer ist
    IsFolderEmpty = CBool(PathIsDirectoryEmpty(Path))
End Function

Public Function HasPrefix(ByVal Path As String, ByVal Prefix As String) As Boolean
    ' Stellt fest, ob ein Pfad das Prefix hat
    HasPrefix = CBool(PathIsPrefix(AddBackslash(Prefix), Path))
End Function

Public Function IsRelative(ByVal Path As String) As Boolean
    ' Stellt fest, ob ein Pfad relativ oder absolut ist
    IsRelative = CBool(PathIsRelative(Path))
End Function

Public Function IsRoot(ByVal Path As String) As Boolean
    ' Stellt fest, ob ein Pfad wie "C:\" oder
    ' wie "C:\windows" ist
    IsRoot = CBool(PathIsRoot(Path))
End Function

Public Function IsURL(ByVal Path As String) As Boolean
    ' Stellt fest, ob Path eine Internet-Adresse ist
    IsURL = CBool(PathIsURL(Path))
End Function

Public Function IsSameDrive(ByVal Path1 As String, ByVal Path2 As String) As Boolean
    ' Stellt fest, ob die Pfade auf dem selben Laufwerk liegen
    IsSameDrive = CBool(PathIsSameRoot(Path1, Path2))
End Function

Public Function IsNetworkPath(ByVal Path As String) As Boolean
    ' Stellt fest, ob Path eine Netzwerk-Adresse ist
    IsNetworkPath = CBool(PathIsUNC(Path))
End Function

Public Function UnQuote(ByVal Path As String) As String
    ' Entfernt evtl. vorhandene Anfhrungszeichen
    Dim sBuf As String
    sBuf = Path + String(100, 0)
    Call PathUnquoteSpaces(sBuf)
    UnQuote = RemNulls(sBuf)
End Function

Public Function Quote(ByVal Path As String) As String
    ' Wenn in Path Leerzeichen vorkommen, Anfhrungszeichen setzen
    Dim sBuf As String
    sBuf = Path + String(100, 0)
    Call PathQuoteSpaces(sBuf)
    Quote = RemNulls(sBuf)
End Function

Public Function GetRoot(ByVal Path As String) As String
    ' Gibt das Laufwerk zurck, z.B. "C:\"
    Dim sBuf As String
    sBuf = Path + String(100, 0)
    Call PathStripToRoot(sBuf)
    GetRoot = RemNulls(sBuf)
End Function

Public Function GetShortPathName(ByVal Path As String)
    ' Gibt den verkrzten Pfad im 8.3-Format zurck
    ' ACHTUNG! Geht nur mit tatschlich existierenden Dateien!
    Dim sBuf As String
    sBuf = Space(255)
    Call APIGetShortPathName(Path, sBuf, Len(sBuf))
    GetShortPathName = RemNulls(sBuf)
End Function

Public Function GetLongPathName(ByVal Path As String)
    ' Wandelt einen Pfad im 8.3-Format ins "normale" zurck
    ' ACHTUNG! Geht nur mit tatschlich existierenden Dateien!
    Dim sBuf As String
    sBuf = String(255, 0)
    Call GetFullPathName(Path, Len(sBuf), sBuf, vbNullString)
    GetLongPathName = RemNulls(sBuf)
End Function

Private Function RemNulls(ByVal sStr As String) As String
    ' Entfernt die Nullzeichen am Ende eines Strings
    Dim lPos As Long
    lPos = InStr(1, sStr, vbNullChar)
    If lPos > 0 Then
        RemNulls = Left(sStr, lPos - 1)
    Else
        RemNulls = sStr
    End If
End Function
